package com.sun.corba.se.spi.presentation.rmi;

import org.omg.CORBA.Object;
import java.util.Map;
import com.sun.corba.se.spi.orbutil.proxy.InvocationHandlerFactory;
import javax.rmi.CORBA.Tie;
import java.lang.reflect.Method;

public interface PresentationManager
{
    public abstract PresentationManager.ClassData getClassData(Class p0);
    
    public abstract DynamicMethodMarshaller getDynamicMethodMarshaller(Method p0);
    
    public abstract PresentationManager.StubFactoryFactory getStubFactoryFactory(boolean p0);
    
    public abstract void setStubFactoryFactory(boolean p0, PresentationManager.StubFactoryFactory p1);
    
    public abstract Tie getTie();
    
    public abstract boolean useDynamicStubs();
    
    public interface ClassData
    {
        public abstract Class getMyClass();
        
        public abstract IDLNameTranslator getIDLNameTranslator();
        
        public abstract String[] getTypeIds();
        
        public abstract InvocationHandlerFactory getInvocationHandlerFactory();
        
        public abstract Map getDictionary();
    }
    
    public interface StubFactory
    {
        public abstract org.omg.CORBA.Object makeStub();
        
        public abstract String[] getTypeIds();
    }
    
    public interface StubFactoryFactory
    {
        public abstract String getStubName(String p0);
        
        public abstract PresentationManager.StubFactory createStubFactory(String p0, boolean p1, String p2, Class p3, ClassLoader p4);
        
        public abstract Tie getTie(Class p0);
        
        public abstract boolean createsDynamicStubs();
    }
}
